## fff 1.1

=== Makefile ===
all:
	mkdir -p build
	cd gtest; $(MAKE) all
	cd test; $(MAKE) all
	cd examples; $(MAKE) all

clean: 
	cd gtest; $(MAKE) clean
	cd test; $(MAKE) clean
	cd examples; $(MAKE) clean

=== examples/Makefile ===
all: 
	cd embedded_ui; $(MAKE) all
	cd driver_testing; $(MAKE) all
	cd weak_linking; $(MAKE) all
clean: 
	cd embedded_ui; $(MAKE) clean
	cd driver_testing; $(MAKE) clean
	cd weak_linking; $(MAKE) clean

=== gtest/Makefile ===

BUILD_DIR = ../build
LIBS := -lpthread
CPP_OBJS=$(BUILD_DIR)/gtest-all.o $(BUILD_DIR)/gtest-main.o

SOURCES=gtest-all.cc gtest-main.cc


# Each subdirectory must supply rules for building sources it contributes
$(BUILD_DIR)/%.o: %.cc
	@echo 'Building file: $<'
	@echo 'Invoking: GCC C++ Compiler'
	g++ -I../ -O0 -g3 -Wall -DGTEST_USE_OWN_TR1_TUPLE=1 -c -o "$@" "$<"
	@echo 'Finished building: $<'
	@echo ' '

all: $(CPP_OBJS)

clean:
	-$(RM) $(CPP_OBJS) 
	-@echo ' '

=== test/Makefile ===

BUILD_DIR = ../build

FFF_TEST_CPP_OBJS += \
$(BUILD_DIR)/fff_test_cpp.o \
$(BUILD_DIR)/gtest-all.o \
$(BUILD_DIR)/gtest-main.o

FFF_TEST_GLOBAL_CPP_OBJS += \
$(BUILD_DIR)/fff_test_global_cpp.o \
$(BUILD_DIR)/global_fakes.o \
$(BUILD_DIR)/gtest-all.o \
$(BUILD_DIR)/gtest-main.o

FFF_TEST_C_OBJS = $(BUILD_DIR)/fff_test_c.o

FFF_TEST_GLOBAL_C_OBJS += \
$(BUILD_DIR)/global_fakes.o \
$(BUILD_DIR)/fff_test_global_c.o

FFF_TEST_CPP_TARGET = $(BUILD_DIR)/fff_test_cpp
FFF_TEST_C_TARGET = $(BUILD_DIR)/fff_test_c
FFF_TEST_GLOBAL_C_TARGET = $(BUILD_DIR)/fff_test_glob_c
FFF_TEST_GLOBAL_CPP_TARGET = $(BUILD_DIR)/fff_test_glob_cpp

LIBS := -lpthread
# All Target
all: $(FFF_TEST_CPP_TARGET) $(FFF_TEST_C_TARGET) $(FFF_TEST_GLOBAL_C_TARGET) $(FFF_TEST_GLOBAL_CPP_TARGET)


# Each subdirectory must supply rules for building sources it contributes
$(BUILD_DIR)/%.o: %.cpp
	@echo 'Building file: $<'
	@echo 'Invoking: GCC C++ Compiler'
	g++ -I../ -O0 -g3 -Wall -DGTEST_USE_OWN_TR1_TUPLE=1 -c -o "$@" "$<"
	@echo 'Finished building: $<'
	@echo ' '

$(BUILD_DIR)/%.o: %.c
	@echo 'Building file: $<'
	@echo 'Invoking: GCC C Compiler'
	gcc -I../ -O0 -g3 -Wall -std=c99 -c -o "$@" "$<"
	@echo 'Finished building: $<'
	@echo ' '


# Link targets
$(FFF_TEST_CPP_TARGET): $(FFF_TEST_CPP_OBJS) 
	@echo 'Building target: $@'
	@echo 'Invoking: GCC C++ Linker'
	g++ -o "$(FFF_TEST_CPP_TARGET)" $(FFF_TEST_CPP_OBJS) $(LIBS)
	@echo 'Finished building target: $@'
	@echo ' '

$(FFF_TEST_C_TARGET): $(FFF_TEST_C_OBJS) 
	@echo 'Building target: $@'
	@echo 'Invoking: GCC C Linker'
	gcc  -o "$(FFF_TEST_C_TARGET)" $(FFF_TEST_C_OBJS) $(LIBS)
	@echo 'Finished building target: $@'
	@echo ' '

$(FFF_TEST_GLOBAL_C_TARGET): $(FFF_TEST_GLOBAL_C_OBJS) 
	@echo 'Building target: $@'
	@echo 'Invoking: GCC C++ Linker'
	gcc  -o "$(FFF_TEST_GLOBAL_C_TARGET)" $(FFF_TEST_GLOBAL_C_OBJS) $(LIBS) $(WRAP_LDFLAGS)
	@echo 'Finished building target: $@'
	@echo ' '

$(FFF_TEST_GLOBAL_CPP_TARGET): $(FFF_TEST_GLOBAL_CPP_OBJS) 
	@echo 'Building target: $@'
	@echo 'Invoking: GCC C++ Linker'
	g++  -o "$(FFF_TEST_GLOBAL_CPP_TARGET)" $(FFF_TEST_GLOBAL_CPP_OBJS) $(LIBS)
	@echo 'Finished building target: $@'
	@echo ' '

# Other Targets
clean:
	-$(RM) $(FFF_TEST_CPP_OBJS) $(FFF_TEST_GLOBAL_C_OBJS) $(FFF_TEST_C_OBJS) \
		$(FFF_TEST_CPP_TARGET) $(FFF_TEST_C_TARGET) $(FFF_TEST_GLOBAL_CPP_TARGET) $(FFF_TEST_GLOBAL_C_TARGET)
	-@echo ' '

=== examples/driver_testing/Makefile ===
$(VERBOSE).SILENT:

BUILD_DIR = ../../build
TEMPLATE_PROGNAME = $(BUILD_DIR)/template
CPP_PROGNAME_NOFFF = $(BUILD_DIR)/driver_testing
CPP_PROGNAME_FFF = $(BUILD_DIR)/driver_testing_fff
CC = gcc
CC += -c
CPP = g++
CPP += -c
LD = g++

GTEST_OBJS = $(BUILD_DIR)/gtest-all.o $(BUILD_DIR)/gtest-main.o
C_OBJFILES = $(BUILD_DIR)/driver.o
TEMPLATE_OBJFILES = $(BUILD_DIR)/test_suite_template.o
FFF_OBJFILES = $(BUILD_DIR)/driver.test.fff.o $(GTEST_OBJS)
NOFFF_OBJFILES = $(BUILD_DIR)/driver.test.o $(GTEST_OBJS)
CPP_LIBS = -lpthread 


all: $(CPP_PROGNAME_NOFFF) $(CPP_PROGNAME_FFF) $(TEMPLATE_PROGNAME)

.PHONY: clean

clean:
	@echo "Cleaning object files"
	@echo "    rm -f     $(BUILD_DIR)/*.o"
	rm -f $(BUILD_DIR)/*.o
	@echo "Cleaning backups"
	@echo "    rm -f     *~"
	rm -f *~
	@echo "Removing programs"
	@echo "    rm -f     $(CPP_PROGNAME_NOFFF) $(CPP_PROGNAME_FFF) $(TEMPLATE_PROGNAME)"
	rm -f $(CPP_PROGNAME_NOFFF) $(CPP_PROGNAME_FFF) $(TEMPLATE_PROGNAME)


$(BUILD_DIR)/%.o: %.c
	@echo "Compiling "$@
	@echo "    CC        "$<
	$(CC)  -o $@ $< -DTESTING

$(BUILD_DIR)/%.o: %.cpp
	@echo "Compiling "$@
	@echo "    CPP       "$<
	$(CPP) -DGTEST_USE_OWN_TR1_TUPLE=1 -I../.. -o $@ $< -DTESTING

$(TEMPLATE_PROGNAME): $(TEMPLATE_OBJFILES)
	@echo "Linking "$@
	@echo "    LD        -o "ctemplate"        "$(TEMPLATE_OBJFILES)
	$(LD) -o $(TEMPLATE_PROGNAME) $(TEMPLATE_OBJFILES)

$(CPP_PROGNAME_FFF): $(FFF_OBJFILES) $(C_OBJFILES)
	@echo "Linking "$@
	@echo "    LD        -o "$(CPP_PROGNAME_FFF)"        "$(FFF_OBJFILES)
	$(LD) -o $(CPP_PROGNAME_FFF) $(FFF_OBJFILES) $(C_OBJFILES) $(CPP_LIBS)

$(CPP_PROGNAME_NOFFF): $(NOFFF_OBJFILES) $(C_OBJFILES)
	@echo "Linking "$@
	@echo "    LD        -o "$(CPP_PROGNAME_NOFFF)"        "$(NOFFF_OBJFILES)
	$(LD) -o $(CPP_PROGNAME_NOFFF) $(NOFFF_OBJFILES) $(C_OBJFILES) $(CPP_LIBS)

nothing:
	@echo "Nothing to do; quitting  :("
	@echo "HINT: Try make all"

=== examples/embedded_ui/Makefile ===
$(VERBOSE).SILENT:

BUILD_DIR = ../../build
TEMPLATE_PROGNAME = $(BUILD_DIR)/template
C_PROGNAME = $(BUILD_DIR)/ui_test_ansic
CPP_PROGNAME = $(BUILD_DIR)/ui_test_cpp
CC = gcc
CC += -c
CPP = g++
CPP += -c
LD = g++

GTEST_OBJS = $(BUILD_DIR)/gtest-all.o $(BUILD_DIR)/gtest-main.o
C_OBJFILES = $(BUILD_DIR)/UI_test_ansic.o $(BUILD_DIR)/UI.o
TEMPLATE_OBJFILES = $(BUILD_DIR)/test_suite_template.o
CPP_OBJFILES = $(BUILD_DIR)/UI_test_cpp.o $(BUILD_DIR)/UI.o $(GTEST_OBJS)
CPP_LIBS = -lpthread 


all: $(C_PROGNAME) $(CPP_PROGNAME) $(TEMPLATE_PROGNAME)

.PHONY: clean

clean:
	@echo "Cleaning object files"
	@echo "    rm -f     $(BUILD_DIR)/*.o"
	rm -f $(BUILD_DIR)/*.o
	@echo "Cleaning backups"
	@echo "    rm -f     *~"
	rm -f *~
	@echo "Removing programs"
	@echo "    rm -f     "$(C_PROGNAME)
	rm -f $(C_PROGNAME)
	@echo "    rm -f     "$(CPP_PROGNAME) $(TEMPLATE_PROGNAME)
	rm -f $(CPP_PROGNAME) $(TEMPLATE_PROGNAME)


$(BUILD_DIR)/%.o: %.c
	@echo "Compiling "$@
	@echo "    CC        "$<
	$(CC)  -o $@ $<

$(BUILD_DIR)/%.o: %.cpp
	@echo "Compiling "$@
	@echo "    CPP       "$<
	$(CPP) -DGTEST_USE_OWN_TR1_TUPLE=1 -I../.. -o $@ $< 

$(TEMPLATE_PROGNAME): $(TEMPLATE_OBJFILES)
	@echo "Linking "$@
	@echo "    LD        -o "ctemplate"        "$(TEMPLATE_OBJFILES)
	$(LD) -o $(TEMPLATE_PROGNAME) $(TEMPLATE_OBJFILES)

$(C_PROGNAME): $(C_OBJFILES)
	@echo "Linking "$@
	@echo "    LD        -o "$(C_PROGNAME)"        "$(C_OBJFILES)
	$(LD) -o $(C_PROGNAME) $(C_OBJFILES)

$(CPP_PROGNAME): $(CPP_OBJFILES) $(C_OBJFILES)
	@echo "Linking "$@
	@echo "    LD        -o "$(CPP_PROGNAME)"        "$(CPP_OBJFILES)
	$(LD) -o $(CPP_PROGNAME) $(CPP_OBJFILES) $(CPP_LIBS)



nothing:
	@echo "Nothing to do; quitting  :("
	@echo "HINT: Try make all"

=== examples/weak_linking/Makefile ===
BUILD_DIR = ../../build
INCLUDE_DIRS = -I "../../" -I "./src/"

BUILD_DIR_FAKE =  $(BUILD_DIR)/weak_linking
CC = gcc
WEAK_FLAGS=-Wall -DFFF_GCC_FUNCTION_ATTRIBUTES="__attribute__((weak))"

$(BUILD_DIR_FAKE)/%.o: test/%.c
	@echo "Compiling "$@
	$(CC) $(WEAK_FLAGS) $(INCLUDE_DIRS) -g -O0 -c $< -o $@

FAKE_OBJECTS = $(BUILD_DIR_FAKE)/display.fake.o $(BUILD_DIR_FAKE)/sensor.fake.o $(BUILD_DIR_FAKE)/sensor.fake.o $(BUILD_DIR_FAKE)/error.fake.o  $(BUILD_DIR_FAKE)/bus.fake.o $(BUILD_DIR_FAKE)/test_common.o

TEST_BINARIES = $(BUILD_DIR_FAKE)/test_main $(BUILD_DIR_FAKE)/test_display $(BUILD_DIR_FAKE)/test_sensor
mkdir:
	mkdir -p $(BUILD_DIR_FAKE)/

clean:
	rm -rf $(BUILD_DIR_FAKE)/

$(BUILD_DIR_FAKE)/libfakes.a:  $(FAKE_OBJECTS)
	ar r $@  $^

# First case where we need __weak__ linking:
#  - If we have the build objects (for some reason) in order where the fake object comes first.
$(BUILD_DIR_FAKE)/test_display: ./test/display.test.c $(BUILD_DIR_FAKE)/libfakes.a ./src/display.c
	$(CC) $(WEAK_FLAGS) $(INCLUDE_DIRS) -o $@ $^

# Second case where we need weak linking:
#  - If we use an object from the fake object -> gcc linker will include it.
$(BUILD_DIR_FAKE)/test_sensor: ./test/sensor.test.c ./src/sensor.c $(BUILD_DIR_FAKE)/libfakes.a
	$(CC) $(WEAK_FLAGS) $(INCLUDE_DIRS) -o $@ $^

# Third case where we need weak linking:
#  - We want to fake one function but not all.
$(BUILD_DIR_FAKE)/test_main: ./test/main.test.c ./src/main.c $(BUILD_DIR_FAKE)/libfakes.a
	$(CC) $(WEAK_FLAGS) $(INCLUDE_DIRS) -o $@ $^

all: mkdir $(TEST_BINARIES)

=== debian/changelog ===
fff (1.1-3) unstable; urgency=medium

  * QA upload.

  [ Chris Lamb ]
  * Make build reproducible
    Closes: #1121804

  [ Andreas Tille ]
  * Maintain in Debian team on Salsa
  * d/watch: version=5
  * Add d/u/metadata

 -- Andreas Tille <tille@debian.org>  Sun, 07 Dec 2025 00:42:47 +0100

fff (1.1-2) unstable; urgency=medium

  * QA upload.
  * Convert to Architecture: all.

 -- Bastian Germann <bage@debian.org>  Thu, 14 Aug 2025 10:32:02 +0200

fff (1.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1016078)

 -- Bastian Germann <bage@debian.org>  Thu, 01 May 2025 10:11:07 +0200

=== debian/control ===
Source: fff
Section: libdevel
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 ruby,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian/fff
Vcs-Git: https://salsa.debian.org/debian/fff.git
Homepage: https://github.com/meekrosoft/fff

Package: libfff-dev
Architecture: all
Depends:
 ${misc:Depends},
Description: Fake Function Framework for C
 fff is a micro-framework for creating fake C functions for tests. Because
 life is too short to spend time hand-writing fake functions for testing.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_test:
	./buildandtest

execute_before_dh_auto_install:
	# buildandtest bumps mtime; set to fixed value
	touch -d@$(SOURCE_DATE_EPOCH) fff.h

=== debian/watch ===
Version: 5

Template: Github
Owner: meekrosoft
Project: fff
